2024-02-26 15:19 UTC

View Issue Details Jump to Notes ]
IDProjectCategoryView StatusLast Update
0002854LibCSSLibCSSpublic2023-09-17 18:53
Reporterphoebos 
Assigned ToMichael Drake 
PrioritynormalSeveritycrashReproducibilityalways
StatusresolvedResolutionfixed 
Platformx86_64OSLinuxOS Version5.15.104
Summary0002854: Netsurf segmentation fault in libcss
DescriptionViewing the page https://stackoverflow.com/questions/45981545/why-does-noreturn-function-return
causes a segfault.
Steps To Reproducerun "netsurf-gtk3 https://stackoverflow.com/questions/45981545/why-does-noreturn-function-return" for libcss and netsurf at latest git commit.
Additional Informationbacktrace:

#0 css__select_revert_property_to_origin
    (select_state=0x7fffffffa2a0, prop_state=0x7fffffffb418, origin=CSS_ORIGIN_USER, pseudo=CSS_PSEUDO_ELEMENT_NONE, property=CSS_PROP_OUTLINE_COLOR)
    at src/select/select.c:1168
#1 0x0000555555793bd4 in css__select_revert_property
    (select_state=select_state@entry=0x7fffffffa2a0, prop_state=prop_state@entry=0x7fffffffb418, pseudo=pseudo@entry=CSS_PSEUDO_ELEMENT_NONE, property=property@entry=CSS_PROP_OUTLINE_COLOR) at src/select/select.c:1193
0000002 0x00005555557961d1 in css_select_style
    (ctx=<optimized out>, node=node@entry=0x7ffff4334980, unit_ctx=unit_ctx@entry=0x7ffff4525cb0, media=media@entry=0x7ffff4525c50, inline_style=inline_style@entry=0x0, handler=handler@entry=0x555555a01d80 <selection_handler>, pw=0x7fffffffbf50, result=0x7fffffffbf00) at src/select/select.c:1406
#3 0x00005555556939ad in nscss_get_style
    (ctx=ctx@entry=0x7fffffffbf50, n=n@entry=0x7ffff4334980, media=media@entry=0x7ffff4525c50, unit_len_ctx=unit_len_ctx@entry=0x7ffff4525cb0, inline_style=inline_style@entry=0x0) at content/handlers/css/select.c:264
#4 0x0000555555693e66 in box_get_style
    (c=0x7ffff4525a40, parent_style=0x7ffff3d70ab0, root_style=0x7ffff42d7b10, n=0x7ffff4334980) at content/handlers/html/box_construct.c:286
#5 0x000055555569450c in box_construct_element
    (ctx=ctx@entry=0x7ffff3608fe0, convert_children=convert_children@entry=0x7fffffffc07b) at content/handlers/html/box_construct.c:495
#6 0x000055555569572f in convert_xml_to_box (ctx=0x7ffff3608fe0)
    at content/handlers/html/box_construct.c:1240
#7 0x0000555555742c5d in schedule_run () at frontends/gtk/schedule.c:148
#8 0x0000555555738908 in nsgtk_main () at frontends/gtk/gui.c:1072
#9 0x00005555555e721c in main (argc=<optimized out>, argv=<optimized out>)
    at frontends/gtk/gui.c:1231
TagsNo tags attached.
Fixed in CI build #
Reported in CI build #
Attached Files
  • ? file icon log (47,949 bytes) 2023-03-31 00:55 -
    (0.000000) [INFO netsurf] frontends/gtk/gui.c:414 get_config_home: "/home/ben/.config/netsurf"
    (0.000098) [INFO netsurf] utils/log.c:269 nslog_init: NetSurf version '3.11 (Dev)'
    (0.000134) [INFO netsurf] utils/log.c:274 nslog_init: NetSurf on <Linux>, node <kiss>, release <5.15.104>, version <#1 SMP Fri Mar 24 23:30:11 GMT 2023>, machine <x86_64>
    (0.000523) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/netsurf.ui
    (0.000626) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/tabcontents.ui
    (0.000718) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/password.ui
    (0.000807) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/toolbar.ui
    (0.000893) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/downloads.ui
    (0.000980) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/globalhistory.ui
    (0.001089) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/localhistory.ui
    (0.001181) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/options.ui
    (0.001265) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/hotlist.ui
    (0.001349) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/cookies.ui
    (0.001444) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/viewdata.ui
    (0.001529) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/warning.ui
    (0.001613) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/pageinfo.ui
    (0.001711) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/favicon.png
    (0.001807) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/netsurf.xpm
    (0.001889) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/menu_cursor.png
    (0.001953) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/local-history.png
    (0.001982) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/show-cookie.png
    (0.002015) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/24x24/actions/page-info-insecure.png
    (0.002045) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/24x24/actions/page-info-internal.png
    (0.002074) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/24x24/actions/page-info-local.png
    (0.002103) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/24x24/actions/page-info-secure.png
    (0.002132) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/24x24/actions/page-info-warning.png
    (0.002160) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/48x48/actions/page-info-insecure.png
    (0.002188) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/48x48/actions/page-info-internal.png
    (0.002217) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/48x48/actions/page-info-local.png
    (0.002246) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/48x48/actions/page-info-secure.png
    (0.002274) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/48x48/actions/page-info-warning.png
    (0.002303) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/throbber/throbber0.png
    (0.002331) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/throbber/throbber1.png
    (0.002365) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/throbber/throbber2.png
    (0.002396) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/throbber/throbber3.png
    (0.002424) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/throbber/throbber4.png
    (0.002452) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/throbber/throbber5.png
    (0.002479) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/throbber/throbber6.png
    (0.002507) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/throbber/throbber7.png
    (0.002534) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/throbber/throbber8.png
    (0.002562) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/welcome.html
    (0.002596) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/credits.html
    (0.002629) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/licence.html
    (0.002664) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/default.css
    (0.002697) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/adblock.css
    (0.002731) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/internal.css
    (0.002764) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/quirks.css
    (0.002797) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/netsurf.png
    (0.002830) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/default.ico
    (0.002863) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/arrow-l.png
    (0.002897) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/content.png
    (0.002930) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/directory2.png
    (0.002963) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/directory.png
    (0.002996) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/hotlist-add.png
    (0.003033) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/hotlist-rmv.png
    (0.003068) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/icons/search.png
    (0.003103) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/languages
    (0.003138) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/accelerators
    (0.003170) [INFO netsurf] frontends/gtk/resources.c:239 init_resource: Found gresource path /org/netsurf/Messages
    (0.046985) [INFO netsurf] utils/nsoption.c:746 nsoption_read: Successfully opened '/home/ben/.config/netsurf/Choices' for Options file
    (0.047857) [INFO netsurf] frontends/gtk/gui.c:699 get_cache_home: "/home/ben/.cache/netsurf"
    (0.048038) [INFO netsurf] content/handlers/image/image_cache.c:429 image_cache_init: Image cache initialised with a limit of 3145728 hysteresis of 629145
    (0.048076) [INFO netsurf] content/handlers/html/css_fetcher.c:70 html_css_fetcher_initialise: html_css_fetcher_initialise called for x-ns-css
    (0.048166) [INFO netsurf] content/fetchers/curl.c:1692 fetch_curl_register: curl_version libcurl/8.0.1 OpenSSL/3.1.0 zlib/1.2.13
    (0.049638) [INFO netsurf] utils/useragent.c:73 user_agent_build_string: Built user agent "Mozilla/5.0 (X11; Linux) NetSurf/3.11"
    (0.049663) [INFO netsurf] content/fetchers/curl.c:1805 fetch_curl_register: cURL linked against openssl
    (0.049718) [INFO netsurf] content/fetchers/curl.c:289 fetch_curl_initialise: Initialise cURL fetcher for http
    (0.049732) [INFO netsurf] content/fetchers/curl.c:289 fetch_curl_initialise: Initialise cURL fetcher for https
    (0.049746) [INFO netsurf] content/fetchers/data.c:61 fetch_data_initialise: fetch_data_initialise called for data
    (0.049761) [INFO netsurf] content/fetchers/resource.c:286 fetch_resource_initialise: direct data for adblock.css
    (0.049779) [INFO netsurf] content/fetchers/resource.c:286 fetch_resource_initialise: direct data for default.css
    (0.049796) [INFO netsurf] content/fetchers/resource.c:286 fetch_resource_initialise: direct data for internal.css
    (0.049813) [INFO netsurf] content/fetchers/resource.c:286 fetch_resource_initialise: direct data for quirks.css
    (0.049862) [INFO netsurf] content/fetchers/resource.c:286 fetch_resource_initialise: direct data for credits.html
    (0.049880) [INFO netsurf] content/fetchers/resource.c:286 fetch_resource_initialise: direct data for licence.html
    (0.049896) [INFO netsurf] content/fetchers/resource.c:286 fetch_resource_initialise: direct data for welcome.html
    (0.049915) [INFO netsurf] content/fetchers/resource.c:294 fetch_resource_initialise: redirect url for favicon.ico
    (0.049933) [INFO netsurf] content/fetchers/resource.c:286 fetch_resource_initialise: direct data for default.ico
    (0.049950) [INFO netsurf] content/fetchers/resource.c:286 fetch_resource_initialise: direct data for netsurf.png
    (0.049967) [INFO netsurf] content/fetchers/resource.c:286 fetch_resource_initialise: direct data for icons/arrow-l.png
    (0.049983) [INFO netsurf] content/fetchers/resource.c:286 fetch_resource_initialise: direct data for icons/content.png
    (0.050000) [INFO netsurf] content/fetchers/resource.c:286 fetch_resource_initialise: direct data for icons/directory.png
    (0.050024) [INFO netsurf] content/fetchers/resource.c:286 fetch_resource_initialise: direct data for icons/directory2.png
    (0.050040) [INFO netsurf] content/fetchers/resource.c:286 fetch_resource_initialise: direct data for icons/hotlist-add.png
    (0.050057) [INFO netsurf] content/fetchers/resource.c:286 fetch_resource_initialise: direct data for icons/hotlist-rmv.png
    (0.050074) [INFO netsurf] content/fetchers/resource.c:286 fetch_resource_initialise: direct data for icons/search.png
    (0.050097) [INFO llcache] content/llcache.c:3899 llcache_initialise: llcache initialising with a limit of 9437184 bytes
    (0.050113) [INFO netsurf] content/fs_backing_store.c:1375 read_control: opening control file "/home/ben/.cache/netsurf/control"
    (0.067562) [INFO netsurf] content/fs_backing_store.c:1210 read_entries: Read 2152 entries from cache
    (0.067584) [INFO netsurf] content/fs_backing_store.c:1238 read_blocks: Initialising block use map from /home/ben/.cache/netsurf/blocks
    (0.067627) [INFO netsurf] content/fs_backing_store.c:1511 initialise: FS backing store init successful
    (0.067641) [INFO netsurf] content/fs_backing_store.c:1513 initialise: path:/home/ben/.cache/netsurf limit:1073741824 hyst:214748364
    (0.067654) [INFO netsurf] content/fs_backing_store.c:1518 initialise: Using 115374507/1073741824
    (0.071374) [INFO netsurf] frontends/gtk/gui.c:939 nsgtk_setup: Seting default window icon
    (0.071491) [INFO netsurf] frontends/gtk/gui.c:947 nsgtk_setup: Using '/home/ben/src/netsurf/resources/SearchEngines' as Search Engines file
    (0.071515) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.071531) [INFO netsurf] content/fetchers/curl.c:471 fetch_curl_setup: fetch 0x7eff5e084b50, url 'https://www.duckduckgo.com/favicon.ico'
    (0.071669) [INFO netsurf] frontends/gtk/throbber.c:71 nsgtk_throbber_init: throbber/throbber0.png
    (0.071715) [INFO netsurf] frontends/gtk/throbber.c:71 nsgtk_throbber_init: throbber/throbber1.png
    (0.071754) [INFO netsurf] frontends/gtk/throbber.c:71 nsgtk_throbber_init: throbber/throbber2.png
    (0.071793) [INFO netsurf] frontends/gtk/throbber.c:71 nsgtk_throbber_init: throbber/throbber3.png
    (0.071832) [INFO netsurf] frontends/gtk/throbber.c:71 nsgtk_throbber_init: throbber/throbber4.png
    (0.071879) [INFO netsurf] frontends/gtk/throbber.c:71 nsgtk_throbber_init: throbber/throbber5.png
    (0.071917) [INFO netsurf] frontends/gtk/throbber.c:71 nsgtk_throbber_init: throbber/throbber6.png
    (0.071957) [INFO netsurf] frontends/gtk/throbber.c:71 nsgtk_throbber_init: throbber/throbber7.png
    (0.071996) [INFO netsurf] frontends/gtk/throbber.c:71 nsgtk_throbber_init: throbber/throbber8.png
    (0.072152) [INFO netsurf] frontends/gtk/gui.c:982 nsgtk_setup: Set CSS DPI to 96
    (0.072171) [INFO netsurf] desktop/bitmap.c:122 bitmap_set_format: Setting core bitmap format to: 0xAARRGGBB (native endian) pre multiplied alpha
    (0.072185) [INFO netsurf] desktop/bitmap.c:129 bitmap_set_format: Sanitised layout to: Byte-wise BGRA
    (0.073531) [INFO netsurf] content/urldb.c:2895 urldb_load: Loading URL file /home/ben/.config/netsurf/URLs
    (0.073671) [INFO netsurf] content/urldb.c:2971 urldb_load: No URLs for 'bbc.com'
    (0.073982) [INFO netsurf] content/urldb.c:2971 urldb_load: No URLs for 'creativecommons.org'
    (0.074725) [INFO netsurf] content/urldb.c:2971 urldb_load: No URLs for 'git.sr.ht'
    (0.075738) [INFO netsurf] content/urldb.c:2971 urldb_load: No URLs for 'www.duckduckgo.com'
    (0.075795) [INFO netsurf] content/urldb.c:3092 urldb_load: Successfully loaded URL file
    (0.076034) [INFO netsurf] desktop/treeview.c:5348 treeview_init: Initialising treeview module
    (0.076130) [INFO netsurf] desktop/treeview.c:5379 treeview_init: Initialised treeview module
    (0.076145) [INFO netsurf] desktop/hotlist.c:1298 hotlist_init: Loading hotlist
    (0.076163) [INFO netsurf] frontends/gtk/layout_pango.c:46 nsfont_pango_check: Creating nsfont_pango_context.
    (0.076338) [INFO netsurf] frontends/gtk/layout_pango.c:51 nsfont_pango_check: Creating nsfont_pango_layout.
    (0.090491) [INFO netsurf] desktop/hotlist.c:1344 hotlist_init: Loaded hotlist
    (0.108947) [INFO netsurf] frontends/gtk/window.c:846 gui_window_create: Creating gui window 0x7eff5dcf5b50 for browser window 0x7eff5df46570
    (0.108979) [INFO netsurf] frontends/gtk/scaffolding.c:1494 nsgtk_new_scaffolding: Constructing a scaffold of 0x7eff5dd54ac0 for gui_window 0x7eff5dcf5b50
    (0.130395) [INFO netsurf] frontends/gtk/scaffolding.c:1575 nsgtk_new_scaffolding: creation complete
    (0.140657) [INFO netsurf] frontends/gtk/tabs.c:216 nsgtk_tab_switch_page_after: sel 0
    (0.140782) [INFO netsurf] desktop/browser_window.c:3321 browser_window_navigate: bw 0x7eff5df46570, url https://stackoverflow.com/questions/45981545/why-does-noreturn-function-return
    (0.141103) [INFO netsurf] desktop/browser_window.c:3527 navigate_internal_real: Loading 'https://stackoverflow.com/questions/45981545/why-does-noreturn-function-return'
    (0.141140) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.141157) [INFO netsurf] content/fetchers/curl.c:471 fetch_curl_setup: fetch 0x7eff5e003e70, url 'https://stackoverflow.com/questions/45981545/why-does-noreturn-function-return'
    (0.141400) [INFO netsurf] frontends/gtk/window.c:1053 gui_window_set_icon: Using default favicon
    (0.141643) [INFO netsurf] content/urldb.c:689 urldb__host_is_ip_address: WARNING: called with non-host 'stackoverflow.com/questions/45981545/why-does-noreturn-function-return'
    (0.185156) [INFO netsurf] content/content.c:201 content__init: url resource:icons/directory2.png -> 0x7eff5d976610
    (0.185213) [INFO netsurf] content/content.c:664 content_add_user: content resource:icons/directory2.png (0x7eff5d976610), user 0x55b806d16213 0x7eff5e037ef0
    (0.185262) [INFO netsurf] content/handlers/image/png.c:210 info_callback: size 17 * 17, rowbytes 68
    (0.185314) [INFO netsurf] content/content.c:79 content_convert: content resource:icons/directory2.png (0x7eff5d976610)
    (0.185354) [INFO netsurf] content/handlers/image/image_cache.c:534 image_cache_add: centry 0x7eff5db80a90, content 0x7eff5d976610, bitmap 0x7eff5d8ef5d0
    (0.185386) [INFO netsurf] content/content.c:201 content__init: url resource:icons/directory.png -> 0x7eff5d9767e0
    (0.185403) [INFO netsurf] content/content.c:664 content_add_user: content resource:icons/directory.png (0x7eff5d9767e0), user 0x55b806d16213 0x7eff5e037e90
    (0.185436) [INFO netsurf] content/handlers/image/png.c:210 info_callback: size 17 * 17, rowbytes 68
    (0.185474) [INFO netsurf] content/content.c:79 content_convert: content resource:icons/directory.png (0x7eff5d9767e0)
    (0.185502) [INFO netsurf] content/handlers/image/image_cache.c:534 image_cache_add: centry 0x7eff5d935490, content 0x7eff5d9767e0, bitmap 0x7eff5db64b70
    (0.185529) [INFO netsurf] content/content.c:201 content__init: url resource:icons/content.png -> 0x7eff5d9769e0
    (0.185546) [INFO netsurf] content/content.c:664 content_add_user: content resource:icons/content.png (0x7eff5d9769e0), user 0x55b806d16213 0x7eff5e037e30
    (0.185584) [INFO netsurf] content/handlers/image/png.c:210 info_callback: size 17 * 17, rowbytes 68
    (0.185646) [INFO netsurf] content/content.c:79 content_convert: content resource:icons/content.png (0x7eff5d9769e0)
    (0.185682) [INFO netsurf] content/handlers/image/image_cache.c:534 image_cache_add: centry 0x7eff5d935620, content 0x7eff5d9769e0, bitmap 0x7eff5d8efb40
    (0.185709) [INFO netsurf] content/content.c:201 content__init: url resource:icons/arrow-l.png -> 0x7eff5d976bd0
    (0.185725) [INFO netsurf] content/content.c:664 content_add_user: content resource:icons/arrow-l.png (0x7eff5d976bd0), user 0x55b806d16213 0x7eff5e037dd0
    (0.185755) [INFO netsurf] content/handlers/image/png.c:210 info_callback: size 17 * 17, rowbytes 68
    (0.185806) [INFO netsurf] content/content.c:79 content_convert: content resource:icons/arrow-l.png (0x7eff5d976bd0)
    (0.185840) [INFO netsurf] content/handlers/image/image_cache.c:534 image_cache_add: centry 0x7eff5d935670, content 0x7eff5d976bd0, bitmap 0x7eff5d8f0510
    (0.185866) [INFO netsurf] content/content.c:201 content__init: url resource:icons/search.png -> 0x7eff5d976de0
    (0.185882) [INFO netsurf] content/content.c:664 content_add_user: content resource:icons/search.png (0x7eff5d976de0), user 0x55b806d16213 0x7eff5e037bd0
    (0.185912) [INFO netsurf] content/handlers/image/png.c:210 info_callback: size 17 * 17, rowbytes 68
    (0.185948) [INFO netsurf] content/content.c:79 content_convert: content resource:icons/search.png (0x7eff5d976de0)
    (0.185975) [INFO netsurf] content/handlers/image/image_cache.c:534 image_cache_add: centry 0x7eff5e0777f0, content 0x7eff5d976de0, bitmap 0x7eff5d8f0710
    (0.186007) [INFO netsurf] content/content.c:664 content_add_user: content resource:icons/search.png (0x7eff5d976de0), user 0x55b806d16213 0x7eff5e0a5920
    (0.186034) [INFO netsurf] desktop/searchweb.c:473 default_ico_callback: default icon 'resource:icons/search.png' retrieved
    (0.289582) [INFO netsurf] content/fetchers/curl.c:1202 fetch_curl_process_headers: HTTP status code 301
    (0.289610) [INFO netsurf] content/fetchers/curl.c:1213 fetch_curl_process_headers: FETCH_REDIRECT, 'https://duckduckgo.com/favicon.ico'
    (0.289623) [INFO netsurf] content/fetchers/curl.c:1130 fetch_curl_abort: fetch 0x7eff5e084b50, url 'https://www.duckduckgo.com/favicon.ico'
    (0.289668) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.289718) [INFO llcache] content/llcache.c:1563 llcache_process_metadata: Processing retrieved data
    (0.289904) [INFO netsurf] content/fetchers/curl.c:1266 fetch_curl_done: done https://www.duckduckgo.com/favicon.ico
    (0.289918) [INFO netsurf] content/fetchers/curl.c:1107 fetch_curl_stop: fetch 0x7eff5e084b50, url 'https://www.duckduckgo.com/favicon.ico'
    (0.290110) [INFO netsurf] content/content.c:201 content__init: url https://duckduckgo.com/favicon.ico -> 0x7eff5d864aa0
    (0.290127) [INFO netsurf] content/content.c:664 content_add_user: content https://duckduckgo.com/favicon.ico (0x7eff5d864aa0), user 0x55b806d16213 0x7eff5e0a51c0
    (0.290143) [INFO netsurf] content/content.c:79 content_convert: content https://duckduckgo.com/favicon.ico (0x7eff5d864aa0)
    (0.290169) [INFO netsurf] desktop/searchweb.c:293 search_web_ico_callback: icon 'https://duckduckgo.com/favicon.ico' retrieved
    (0.373185) [INFO netsurf] content/fetchers/curl.c:1202 fetch_curl_process_headers: HTTP status code 200
    (0.373491) [INFO netsurf] content/content.c:201 content__init: url https://stackoverflow.com/questions/45981545/why-does-noreturn-function-return -> 0x7eff5d7eaaf0
    (0.373673) [INFO netsurf] content/handlers/html/css.c:613 html_css_new_stylesheets: 2 fetches active
    (0.373701) [INFO netsurf] content/handlers/html/css.c:640 html_css_new_stylesheets: 3 fetches active
    (0.373714) [INFO netsurf] content/content.c:664 content_add_user: content https://stackoverflow.com/questions/45981545/why-does-noreturn-function-return (0x7eff5d7eaaf0), user 0x55b806d16213 0x7eff5dcf8980
    (0.375284) [INFO netsurf] content/handlers/html/css.c:120 html_convert_css_callback: stylesheet resource:user.css failed: UnacceptableType
    (0.375305) [INFO netsurf] content/handlers/html/css.c:127 html_convert_css_callback: 2 fetches active
    (0.375324) [INFO netsurf] content/content.c:201 content__init: url resource:default.css -> 0x7eff5d963310
    (0.375515) [INFO netsurf] content/content.c:664 content_add_user: content resource:default.css (0x7eff5d963310), user 0x55b806d16213 0x7eff5d7e9c30
    (0.376249) [INFO netsurf] content/content.c:79 content_convert: content resource:default.css (0x7eff5d963310)
    (0.376277) [INFO netsurf] content/handlers/html/css.c:113 html_convert_css_callback: done stylesheet slot 0 'resource:default.css'
    (0.376290) [INFO netsurf] content/handlers/html/css.c:116 html_convert_css_callback: 1 fetches active
    (0.376436) [INFO netsurf] desktop/browser_window.c:590 browser_window_update_favicon: fetching favicon rel:shortcut icon 'https://cdn.sstatic.net/Sites/stackoverflow/Img/favicon.ico?v=ec617d715196'
    (0.376457) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.376532) [INFO llcache] content/llcache.c:1563 llcache_process_metadata: Processing retrieved data
    (0.376962) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.376989) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.377017) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.377038) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.377169) [INFO netsurf] content/handlers/html/css.c:446 html_css_process_link: linked stylesheet 4 'https://cdn.sstatic.net/Shared/stacks.css?v=83d4b324173a'
    (0.377184) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.377196) [INFO netsurf] content/fetchers/curl.c:471 fetch_curl_setup: fetch 0x7eff5d98d490, url 'https://cdn.sstatic.net/Shared/stacks.css?v=83d4b324173a'
    (0.377265) [INFO netsurf] content/handlers/html/css.c:482 html_css_process_link: 2 fetches active
    (0.377306) [INFO netsurf] content/handlers/html/css.c:446 html_css_process_link: linked stylesheet 5 'https://cdn.sstatic.net/Sites/stackoverflow/primary.css?v=2303a2f6cce5'
    (0.377322) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.377333) [INFO netsurf] content/fetchers/curl.c:471 fetch_curl_setup: fetch 0x7eff5d8a77b0, url 'https://cdn.sstatic.net/Sites/stackoverflow/primary.css?v=2303a2f6cce5'
    (0.377380) [INFO netsurf] content/handlers/html/css.c:482 html_css_process_link: 3 fetches active
    (0.377422) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.377501) [INFO netsurf] content/handlers/html/css.c:446 html_css_process_link: linked stylesheet 6 'https://cdn.sstatic.net/Shared/Channels/channels.css?v=a5fae8812988'
    (0.377517) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.377562) [INFO llcache] content/llcache.c:1563 llcache_process_metadata: Processing retrieved data
    (0.377679) [INFO netsurf] content/handlers/html/css.c:482 html_css_process_link: 4 fetches active
    (0.377717) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.377765) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.377791) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.377808) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.378673) [INFO netsurf] content/content.c:201 content__init: url https://cdn.sstatic.net/Shared/Channels/channels.css?v=a5fae8812988 -> 0x7eff5d962d50
    (0.378718) [INFO netsurf] content/content.c:664 content_add_user: content https://cdn.sstatic.net/Shared/Channels/channels.css?v=a5fae8812988 (0x7eff5d962d50), user 0x55b806d16213 0x7eff5d7b5160
    (0.381460) [INFO netsurf] content/content.c:79 content_convert: content https://cdn.sstatic.net/Shared/Channels/channels.css?v=a5fae8812988 (0x7eff5d962d50)
    (0.381528) [INFO netsurf] content/handlers/html/css.c:113 html_convert_css_callback: done stylesheet slot 6 'https://cdn.sstatic.net/Shared/Channels/channels.css?v=a5fae8812988'
    (0.381545) [INFO netsurf] content/handlers/html/css.c:116 html_convert_css_callback: 3 fetches active
    (0.381567) [INFO netsurf] content/content.c:201 content__init: url https://cdn.sstatic.net/Sites/stackoverflow/Img/favicon.ico?v=ec617d715196 -> 0x7eff5d8642d0
    (0.381583) [INFO netsurf] content/content.c:664 content_add_user: content https://cdn.sstatic.net/Sites/stackoverflow/Img/favicon.ico?v=ec617d715196 (0x7eff5d8642d0), user 0x55b806d16213 0x7eff5d7b0820
    (0.383263) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.384163) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.384207) [INFO llcache] content/llcache.c:1563 llcache_process_metadata: Processing retrieved data
    (0.385985) [INFO netsurf] content/content.c:201 content__init: url https://cdn.sstatic.net/Img/teams/teams-illo-free-sidebar-promo.svg?v=47faa659a05e -> 0x7eff5d8631b0
    (0.386006) [INFO netsurf] content/content.c:664 content_add_user: content https://cdn.sstatic.net/Img/teams/teams-illo-free-sidebar-promo.svg?v=47faa659a05e (0x7eff5d8631b0), user 0x55b806d16213 0x7eff5d6bdcf0
    (0.386034) [INFO netsurf] content/content.c:79 content_convert: content https://cdn.sstatic.net/Img/teams/teams-illo-free-sidebar-promo.svg?v=47faa659a05e (0x7eff5d8631b0)
    (0.388092) [INFO netsurf] content/handlers/image/image_cache.c:534 image_cache_add: centry 0x7eff5d6fbbb0, content 0x7eff5d8631b0, bitmap 0
    (0.388121) [INFO netsurf] content/content.c:79 content_convert: content https://cdn.sstatic.net/Sites/stackoverflow/Img/favicon.ico?v=ec617d715196 (0x7eff5d8642d0)
    (0.388154) [INFO netsurf] frontends/gtk/window.c:1047 gui_window_set_icon: Using 0x7eff5d668b10 bitmap
    (0.388238) [INFO netsurf] content/handlers/html/css.c:195 html_stylesheet_from_domnode: 4 fetches active
    (0.388252) [INFO netsurf] content/handlers/html/css.c:274 html_css_process_modified_style: Updating sheet 0 with 0x7eff5d668b70
    (0.388279) [INFO netsurf] content/handlers/html/css.c:195 html_stylesheet_from_domnode: 5 fetches active
    (0.388292) [INFO netsurf] content/handlers/html/css.c:274 html_css_process_modified_style: Updating sheet 0 with 0x7eff5d668c30
    (0.388569) [INFO netsurf] content/content.c:201 content__init: url x-ns-css:0 -> 0x7eff5d6a7470
    (0.388595) [INFO netsurf] content/content.c:664 content_add_user: content x-ns-css:0 (0x7eff5d6a7470), user 0x55b806d16213 0x7eff5d668b70
    (0.388624) [INFO netsurf] content/content.c:79 content_convert: content x-ns-css:0 (0x7eff5d6a7470)
    (0.388639) [INFO netsurf] content/handlers/html/css.c:113 html_convert_css_callback: done stylesheet slot 7 'x-ns-css:0'
    (0.388652) [INFO netsurf] content/handlers/html/css.c:116 html_convert_css_callback: 4 fetches active
    (0.388928) [INFO netsurf] content/content.c:201 content__init: url x-ns-css:1 -> 0x7eff5d6a7670
    (0.388955) [INFO netsurf] content/content.c:664 content_add_user: content x-ns-css:1 (0x7eff5d6a7670), user 0x55b806d16213 0x7eff5d668c30
    (0.388970) [INFO netsurf] content/content.c:79 content_convert: content x-ns-css:1 (0x7eff5d6a7670)
    (0.388984) [INFO netsurf] content/handlers/html/css.c:113 html_convert_css_callback: done stylesheet slot 8 'x-ns-css:1'
    (0.388996) [INFO netsurf] content/handlers/html/css.c:116 html_convert_css_callback: 3 fetches active
    (0.480288) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.480310) [INFO netsurf] content/fetchers/curl.c:471 fetch_curl_setup: fetch 0x7eff5d783b50, url 'https://i.stack.imgur.com/gzBQY.jpg?s=64&g=1'
    (0.483021) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.483040) [INFO netsurf] content/fetchers/curl.c:471 fetch_curl_setup: fetch 0x7eff5d784e70, url 'https://i.stack.imgur.com/hvS4q.png?s=64&g=1'
    (0.483308) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.483322) [INFO netsurf] content/fetchers/curl.c:471 fetch_curl_setup: fetch 0x7eff5d7835b0, url 'https://i.stack.imgur.com/4dwoM.jpg?s=64&g=1'
    (0.485697) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.485715) [INFO netsurf] content/fetchers/curl.c:471 fetch_curl_setup: fetch 0x7eff5d7849f0, url 'https://www.gravatar.com/avatar/e38adc5559df095cfe10c664916e8ffa?s=64&d=identicon&r=PG&f=1'
    (0.488071) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.488088) [INFO netsurf] content/fetchers/curl.c:471 fetch_curl_setup: fetch 0x7eff5d784690, url 'https://www.gravatar.com/avatar/4139ee1298ce4b0690a788cb97d47569?s=64&d=identicon&r=PG&f=1'
    (0.489595) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.489612) [INFO netsurf] content/fetchers/curl.c:471 fetch_curl_setup: fetch 0x7eff5d7848d0, url 'https://i.stack.imgur.com/yCVF0.jpg?s=64&g=1'
    (0.491123) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.491139) [INFO netsurf] content/fetchers/curl.c:471 fetch_curl_setup: fetch 0x7eff5d7840f0, url 'https://www.gravatar.com/avatar/5ca341b160687d99b1317859f91054ee?s=64&d=identicon&r=PG'
    (0.492803) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.492827) [INFO netsurf] content/fetchers/curl.c:471 fetch_curl_setup: fetch 0x7eff5d784450, url 'https://www.gravatar.com/avatar/7e31e63c623c67fad9d407a84729c725?s=64&d=identicon&r=PG'
    (0.494353) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.494377) [INFO netsurf] content/fetchers/curl.c:471 fetch_curl_setup: fetch 0x7eff5d36b010, url 'https://i.stack.imgur.com/SuxtS.gif?s=64&g=1'
    (0.496443) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.496460) [INFO netsurf] content/fetchers/curl.c:471 fetch_curl_setup: fetch 0x7eff5d36beb0, url 'https://i.stack.imgur.com/epYPz.png?s=64&g=1'
    (0.499844) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.499862) [INFO netsurf] content/fetchers/curl.c:471 fetch_curl_setup: fetch 0x7eff5d36b370, url 'https://i.stack.imgur.com/N4ivW.png?s=64&g=1'
    (0.500274) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.500312) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.515429) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.516638) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.517863) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.518853) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.521020) [INFO netsurf] content/fetchers/curl.c:1266 fetch_curl_done: done https://stackoverflow.com/questions/45981545/why-does-noreturn-function-return
    (0.521039) [INFO netsurf] content/fetchers/curl.c:1107 fetch_curl_stop: fetch 0x7eff5e003e70, url 'https://stackoverflow.com/questions/45981545/why-does-noreturn-function-return'
    (0.521824) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.521881) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.521896) [INFO netsurf] content/fetchers/curl.c:471 fetch_curl_setup: fetch 0x7eff5e003e70, url 'https://stackoverflow.com/posts/45981545/ivc/0f6a?prg=591522e4-f6bb-4090-8139-bac4a81c50bf'
    (0.521995) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.522066) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.524869) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.524889) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.524907) [INFO netsurf] content/handlers/html/dom_event.c:265 dom_SCRIPT_showed_up: Encountered a script, but scripting is off, ignoring
    (0.525602) [INFO netsurf] content/content.c:79 content_convert: content https://stackoverflow.com/questions/45981545/why-does-noreturn-function-return (0x7eff5d7eaaf0)
    (0.525620) [INFO netsurf] content/handlers/html/html.c:794 html_convert: quirks set to 0
    (0.525630) [INFO netsurf] content/handlers/html/html.c:798 html_convert: 2 fetches active (0x7eff5d7eaaf0)
    (0.538797) [INFO netsurf] content/fetchers/curl.c:1202 fetch_curl_process_headers: HTTP status code 200
    (0.539377) [INFO netsurf] content/content.c:201 content__init: url https://cdn.sstatic.net/Sites/stackoverflow/primary.css?v=2303a2f6cce5 -> 0x7eff5d0ed680
    (0.539411) [INFO netsurf] content/content.c:664 content_add_user: content https://cdn.sstatic.net/Sites/stackoverflow/primary.css?v=2303a2f6cce5 (0x7eff5d0ed680), user 0x55b806d16213 0x7eff5d7b4fe0
    (0.548839) [INFO netsurf] content/fetchers/curl.c:1202 fetch_curl_process_headers: HTTP status code 200
    (0.556832) [INFO netsurf] content/content.c:201 content__init: url https://cdn.sstatic.net/Shared/stacks.css?v=83d4b324173a -> 0x7eff5d275940
    (0.556871) [INFO netsurf] content/content.c:664 content_add_user: content https://cdn.sstatic.net/Shared/stacks.css?v=83d4b324173a (0x7eff5d275940), user 0x55b806d16213 0x7eff5d7b1dd0
    (0.570972) [INFO netsurf] content/fetchers/curl.c:1266 fetch_curl_done: done https://cdn.sstatic.net/Sites/stackoverflow/primary.css?v=2303a2f6cce5
    (0.570993) [INFO netsurf] content/fetchers/curl.c:1107 fetch_curl_stop: fetch 0x7eff5d8a77b0, url 'https://cdn.sstatic.net/Sites/stackoverflow/primary.css?v=2303a2f6cce5'
    (0.590564) [INFO netsurf] content/content.c:79 content_convert: content https://cdn.sstatic.net/Sites/stackoverflow/primary.css?v=2303a2f6cce5 (0x7eff5d0ed680)
    (0.590614) [INFO netsurf] content/handlers/html/css.c:113 html_convert_css_callback: done stylesheet slot 5 'https://cdn.sstatic.net/Sites/stackoverflow/primary.css?v=2303a2f6cce5'
    (0.590631) [INFO netsurf] content/handlers/html/css.c:116 html_convert_css_callback: 1 fetches active
    (0.645197) [INFO netsurf] content/fetchers/curl.c:1266 fetch_curl_done: done https://cdn.sstatic.net/Shared/stacks.css?v=83d4b324173a
    (0.645224) [INFO netsurf] content/fetchers/curl.c:1107 fetch_curl_stop: fetch 0x7eff5d98d490, url 'https://cdn.sstatic.net/Shared/stacks.css?v=83d4b324173a'
    (0.671472) [INFO netsurf] content/content.c:79 content_convert: content https://cdn.sstatic.net/Shared/stacks.css?v=83d4b324173a (0x7eff5d275940)
    (0.671535) [INFO netsurf] content/handlers/html/css.c:113 html_convert_css_callback: done stylesheet slot 4 'https://cdn.sstatic.net/Shared/stacks.css?v=83d4b324173a'
    (0.671551) [INFO netsurf] content/handlers/html/css.c:116 html_convert_css_callback: 0 fetches active
    (0.671563) [INFO netsurf] content/handlers/html/html.c:854 html_begin_conversion: Completing parse (0x7eff5d7eaaf0)
    (0.672115) [INFO netsurf] content/handlers/html/html.c:389 html_finish_conversion: DOM to box (0x7eff5d7eaaf0)
    (0.684354) [INFO llcache] content/llcache.c:1552 llcache_process_metadata: Retrieving metadata
    (0.684401) [INFO llcache] content/llcache.c:1563 llcache_process_metadata: Processing retrieved data
    (0.684511) [INFO netsurf] content/handlers/html/object.c:767 html_fetch_object: 1 fetches active
    (0.685250) [INFO netsurf] content/content.c:201 content__init: url https://cdn.sstatic.net/Img/unified/sprites.svg?v=fcc0ea44ba27 -> 0x7eff5d7ee4c0
    (0.685271) [INFO netsurf] content/content.c:664 content_add_user: content https://cdn.sstatic.net/Img/unified/sprites.svg?v=fcc0ea44ba27 (0x7eff5d7ee4c0), user 0x55b806d16213 0x7eff5cc9a860
    (0.685287) [INFO netsurf] content/content.c:79 content_convert: content https://cdn.sstatic.net/Img/unified/sprites.svg?v=fcc0ea44ba27 (0x7eff5d7ee4c0)
    (0.686215) [INFO netsurf] content/handlers/image/image_cache.c:534 image_cache_add: centry 0x7eff5c99c4e0, content 0x7eff5d7ee4c0, bitmap 0
    (0.686240) [INFO netsurf] content/handlers/html/object.c:198 html_object_callback: 0 fetches active
    (0.686947) [INFO netsurf] content/fetchers/curl.c:1202 fetch_curl_process_headers: HTTP status code 200
    (0.687822) [INFO netsurf] content/content.c:201 content__init: url https://www.gravatar.com/avatar/e38adc5559df095cfe10c664916e8ffa?s=64&d=identicon&r=PG&f=1 -> 0x7eff5ceec9d0
    (0.687870) [INFO netsurf] content/content.c:664 content_add_user: content https://www.gravatar.com/avatar/e38adc5559df095cfe10c664916e8ffa?s=64&d=identicon&r=PG&f=1 (0x7eff5ceec9d0), user 0x55b806d16213 0x7eff5d4cb370
    (0.688102) [INFO netsurf] content/fetchers/curl.c:1266 fetch_curl_done: done https://www.gravatar.com/avatar/e38adc5559df095cfe10c664916e8ffa?s=64&d=identicon&r=PG&f=1
    (0.688119) [INFO netsurf] content/fetchers/curl.c:1107 fetch_curl_stop: fetch 0x7eff5d7849f0, url 'https://www.gravatar.com/avatar/e38adc5559df095cfe10c664916e8ffa?s=64&d=identicon&r=PG&f=1'
    (0.688240) [INFO netsurf] content/fetchers/curl.c:1202 fetch_curl_process_headers: HTTP status code 200
    (0.689165) [INFO netsurf] content/content.c:201 content__init: url https://www.gravatar.com/avatar/4139ee1298ce4b0690a788cb97d47569?s=64&d=identicon&r=PG&f=1 -> 0x7eff5ceeecb0
    (0.689200) [INFO netsurf] content/content.c:664 content_add_user: content https://www.gravatar.com/avatar/4139ee1298ce4b0690a788cb97d47569?s=64&d=identicon&r=PG&f=1 (0x7eff5ceeecb0), user 0x55b806d16213 0x7eff5d469900
    (0.689240) [INFO netsurf] content/content.c:79 content_convert: content https://www.gravatar.com/avatar/e38adc5559df095cfe10c664916e8ffa?s=64&d=identicon&r=PG&f=1 (0x7eff5ceec9d0)
    (0.689259) [INFO netsurf] content/handlers/image/image_cache.c:534 image_cache_add: centry 0x7eff5c979840, content 0x7eff5ceec9d0, bitmap 0
    (0.689365) [INFO netsurf] content/fetchers/curl.c:1266 fetch_curl_done: done https://www.gravatar.com/avatar/4139ee1298ce4b0690a788cb97d47569?s=64&d=identicon&r=PG&f=1
    (0.689379) [INFO netsurf] content/fetchers/curl.c:1107 fetch_curl_stop: fetch 0x7eff5d784690, url 'https://www.gravatar.com/avatar/4139ee1298ce4b0690a788cb97d47569?s=64&d=identicon&r=PG&f=1'
    (0.690332) [INFO netsurf] content/content.c:79 content_convert: content https://www.gravatar.com/avatar/4139ee1298ce4b0690a788cb97d47569?s=64&d=identicon&r=PG&f=1 (0x7eff5ceeecb0)
    (0.690356) [INFO netsurf] content/handlers/image/image_cache.c:534 image_cache_add: centry 0x7eff5c979890, content 0x7eff5ceeecb0, bitmap 0
    (0.690479) [INFO netsurf] content/fetchers/curl.c:1202 fetch_curl_process_headers: HTTP status code 200
    (0.690638) [INFO netsurf] content/fetchers/curl.c:1202 fetch_curl_process_headers: HTTP status code 200
    (0.690877) [INFO netsurf] content/fetchers/curl.c:1266 fetch_curl_done: done https://i.stack.imgur.com/gzBQY.jpg?s=64&g=1
    (0.690891) [INFO netsurf] content/fetchers/curl.c:1107 fetch_curl_stop: fetch 0x7eff5d783b50, url 'https://i.stack.imgur.com/gzBQY.jpg?s=64&g=1'
    (0.690949) [INFO netsurf] content/fetchers/curl.c:1266 fetch_curl_done: done https://i.stack.imgur.com/4dwoM.jpg?s=64&g=1
    (0.690960) [INFO netsurf] content/fetchers/curl.c:1107 fetch_curl_stop: fetch 0x7eff5d7835b0, url 'https://i.stack.imgur.com/4dwoM.jpg?s=64&g=1'
    (0.691074) [INFO netsurf] content/fetchers/curl.c:1202 fetch_curl_process_headers: HTTP status code 200
    (0.691182) [INFO netsurf] content/fetchers/curl.c:1266 fetch_curl_done: done https://i.stack.imgur.com/hvS4q.png?s=64&g=1
    (0.691194) [INFO netsurf] content/fetchers/curl.c:1107 fetch_curl_stop: fetch 0x7eff5d784e70, url 'https://i.stack.imgur.com/hvS4q.png?s=64&g=1'
    (0.691983) [INFO netsurf] content/content.c:201 content__init: url https://i.stack.imgur.com/4dwoM.jpg?s=64&g=1 -> 0x7eff5d263800
    (0.692002) [INFO netsurf] content/content.c:664 content_add_user: content https://i.stack.imgur.com/4dwoM.jpg?s=64&g=1 (0x7eff5d263800), user 0x55b806d16213 0x7eff5d532e90
    (0.692045) [INFO netsurf] content/content.c:201 content__init: url https://i.stack.imgur.com/hvS4q.png?s=64&g=1 -> 0x7eff5d1dc140
    (0.692061) [INFO netsurf] content/content.c:664 content_add_user: content https://i.stack.imgur.com/hvS4q.png?s=64&g=1 (0x7eff5d1dc140), user 0x55b806d16213 0x7eff5d530df0
    (0.692080) [INFO netsurf] content/content.c:201 content__init: url https://i.stack.imgur.com/gzBQY.jpg?s=64&g=1 -> 0x7eff5d264140
    (0.692091) [INFO netsurf] content/content.c:664 content_add_user: content https://i.stack.imgur.com/gzBQY.jpg?s=64&g=1 (0x7eff5d264140), user 0x55b806d16213 0x7eff5d721740
    (0.693134) [INFO netsurf] content/content.c:79 content_convert: content https://i.stack.imgur.com/4dwoM.jpg?s=64&g=1 (0x7eff5d263800)
    (0.693195) [INFO netsurf] content/handlers/image/image_cache.c:534 image_cache_add: centry 0x7eff5d763430, content 0x7eff5d263800, bitmap 0
    (0.693278) [INFO netsurf] content/handlers/image/png.c:80 nspng_warning: iCCP: known incorrect sRGB profile
    (0.693294) [INFO netsurf] content/content.c:79 content_convert: content https://i.stack.imgur.com/hvS4q.png?s=64&g=1 (0x7eff5d1dc140)
    (0.693318) [INFO netsurf] content/handlers/image/image_cache.c:534 image_cache_add: centry 0x7eff5d763480, content 0x7eff5d1dc140, bitmap 0
    (0.693335) [INFO netsurf] content/content.c:79 content_convert: content https://i.stack.imgur.com/gzBQY.jpg?s=64&g=1 (0x7eff5d264140)
    (0.693368) [INFO netsurf] content/handlers/image/image_cache.c:534 image_cache_add: centry 0x7eff5c997670, content 0x7eff5d264140, bitmap 0
    (0.693469) [INFO netsurf] content/fetchers/curl.c:1202 fetch_curl_process_headers: HTTP status code 200
    (0.693690) [INFO netsurf] content/fetchers/curl.c:1266 fetch_curl_done: done https://www.gravatar.com/avatar/5ca341b160687d99b1317859f91054ee?s=64&d=identicon&r=PG
    (0.693705) [INFO netsurf] content/fetchers/curl.c:1107 fetch_curl_stop: fetch 0x7eff5d7840f0, url 'https://www.gravatar.com/avatar/5ca341b160687d99b1317859f91054ee?s=64&d=identicon&r=PG'
    (0.694545) [INFO netsurf] content/content.c:201 content__init: url https://www.gravatar.com/avatar/5ca341b160687d99b1317859f91054ee?s=64&d=identicon&r=PG -> 0x7eff5d263fc0
    (0.694567) [INFO netsurf] content/content.c:664 content_add_user: content https://www.gravatar.com/avatar/5ca341b160687d99b1317859f91054ee?s=64&d=identicon&r=PG (0x7eff5d263fc0), user 0x55b806d16213 0x7eff5d3f4610
    (0.695423) [INFO netsurf] content/content.c:79 content_convert: content https://www.gravatar.com/avatar/5ca341b160687d99b1317859f91054ee?s=64&d=identicon&r=PG (0x7eff5d263fc0)
    (0.695499) [INFO netsurf] content/handlers/image/image_cache.c:534 image_cache_add: centry 0x7eff5c979d40, content 0x7eff5d263fc0, bitmap 0
    (0.695612) [INFO netsurf] content/fetchers/curl.c:1202 fetch_curl_process_headers: HTTP status code 200
    (0.695691) [INFO netsurf] content/fetchers/curl.c:1266 fetch_curl_done: done https://www.gravatar.com/avatar/7e31e63c623c67fad9d407a84729c725?s=64&d=identicon&r=PG
    (0.695704) [INFO netsurf] content/fetchers/curl.c:1107 fetch_curl_stop: fetch 0x7eff5d784450, url 'https://www.gravatar.com/avatar/7e31e63c623c67fad9d407a84729c725?s=64&d=identicon&r=PG'
    (0.696464) [INFO netsurf] content/handlers/html/object.c:767 html_fetch_object: 1 fetches active
    (0.696774) [INFO netsurf] content/content.c:201 content__init: url https://www.gravatar.com/avatar/7e31e63c623c67fad9d407a84729c725?s=64&d=identicon&r=PG -> 0x7eff5d234410
    (0.696794) [INFO netsurf] content/content.c:664 content_add_user: content https://www.gravatar.com/avatar/7e31e63c623c67fad9d407a84729c725?s=64&d=identicon&r=PG (0x7eff5d234410), user 0x55b806d16213 0x7eff5d3a9260
    (0.696830) [INFO netsurf] content/content.c:664 content_add_user: content https://cdn.sstatic.net/Img/teams/teams-illo-free-sidebar-promo.svg?v=47faa659a05e (0x7eff5d8631b0), user 0x55b806d16213 0x7eff5d1fc800
    (0.696844) [INFO netsurf] content/handlers/html/object.c:198 html_object_callback: 0 fetches active
    (0.697634) [INFO netsurf] content/content.c:79 content_convert: content https://www.gravatar.com/avatar/7e31e63c623c67fad9d407a84729c725?s=64&d=identicon&r=PG (0x7eff5d234410)
    (0.697658) [INFO netsurf] content/handlers/image/image_cache.c:534 image_cache_add: centry 0x7eff5d766e40, content 0x7eff5d234410, bitmap 0
    (0.700575) [INFO netsurf] content/fetchers/curl.c:1202 fetch_curl_process_headers: HTTP status code 200
    (0.700661) [INFO netsurf] content/fetchers/curl.c:1266 fetch_curl_done: done https://i.stack.imgur.com/SuxtS.gif?s=64&g=1
    (0.700674) [INFO netsurf] content/fetchers/curl.c:1107 fetch_curl_stop: fetch 0x7eff5d36b010, url 'https://i.stack.imgur.com/SuxtS.gif?s=64&g=1'
    (0.701608) [INFO netsurf] content/content.c:201 content__init: url https://i.stack.imgur.com/SuxtS.gif?s=64&g=1 -> 0x7eff5d369b10
    (0.701629) [INFO netsurf] content/content.c:664 content_add_user: content https://i.stack.imgur.com/SuxtS.gif?s=64&g=1 (0x7eff5d369b10), user 0x55b806d16213 0x7eff5d379f10
    (0.701784) [INFO netsurf] content/fetchers/curl.c:1202 fetch_curl_process_headers: HTTP status code 200
    (0.702547) [INFO netsurf] content/content.c:79 content_convert: content https://i.stack.imgur.com/SuxtS.gif?s=64&g=1 (0x7eff5d369b10)
    (0.702605) [INFO netsurf] content/content.c:201 content__init: url https://i.stack.imgur.com/yCVF0.jpg?s=64&g=1 -> 0x7eff5d36a610
    (0.702619) [INFO netsurf] content/content.c:664 content_add_user: content https://i.stack.imgur.com/yCVF0.jpg?s=64&g=1 (0x7eff5d36a610), user 0x55b806d16213 0x7eff5d4418e0
    (0.702727) [INFO netsurf] content/fetchers/curl.c:1266 fetch_curl_done: done https://i.stack.imgur.com/yCVF0.jpg?s=64&g=1
    (0.702740) [INFO netsurf] content/fetchers/curl.c:1107 fetch_curl_stop: fetch 0x7eff5d7848d0, url 'https://i.stack.imgur.com/yCVF0.jpg?s=64&g=1'
    (0.703434) [INFO netsurf] content/content.c:79 content_convert: content https://i.stack.imgur.com/yCVF0.jpg?s=64&g=1 (0x7eff5d36a610)
    (0.703481) [INFO netsurf] content/handlers/image/image_cache.c:534 image_cache_add: centry 0x7eff5c99c580, content 0x7eff5d36a610, bitmap 0
    Segmentation fault
    
    ? file icon log (47,949 bytes) 2023-03-31 00:55 +
  • patch file icon 0001-src-stylesheet.h-set-uses_revert-flag-for-shorthand-.patch (2,207 bytes) 2023-08-13 00:27 -
    From 909c6856ca5b2eff12ab8a317f8c9e4c1a895203 Mon Sep 17 00:00:00 2001
    From: Michael Orlitzky <michael@orlitzky.com>
    Date: Sat, 12 Aug 2023 20:03:01 -0400
    Subject: [PATCH 1/1] src/stylesheet.h: set uses_revert flag for shorthand
     properties
    
    Take for example the list-style and list-style-type properties; the
    former is a shorthand property that subsumes the latter. When the
    list-style-type property is parsed, the "flags" variable has its
    FLAG_REVERT bit set, and we call,
    
      css__stylesheet_style_appendOPV(result,
                                      CSS_PROP_LIST_STYLE_TYPE,
    				  flags,
    				  value);
    
    which then sets the "uses_revert" bit on the stylesheet:
    
      if ((flags & (0x7 << 1)) == FLAG_REVERT) {
        style->sheet->uses_revert = true;
      }
    
    In contrast, when list-style is parsed and a flag is found, we run
    
      error = css_stylesheet_style_flag_value(result,
                                              flag_value,
                                              CSS_PROP_LIST_STYLE_TYPE);
    
    which immediately delegates to css__stylesheet_style_append() and
    buildOPV() without checking if "uses_revert" needs to be set. This can
    lead to segfault when we try to revert to a state that we have not
    saved (Mantis bug 2854).
    
    Adding a FLAG_REVERT check to css_stylesheet_style_flag_value() fixes
    the issue for the shorthand properties listed in docs/Bytecode, most
    (but not all) of which experienced the crash.
    
    Closes: https://bugs.netsurf-browser.org/mantis/view.php?id=2854
    ---
     src/stylesheet.h | 6 +++++-
     1 file changed, 5 insertions(+), 1 deletion(-)
    
    diff --git a/src/stylesheet.h b/src/stylesheet.h
    index 070508f..673bc95 100644
    --- a/src/stylesheet.h
    +++ b/src/stylesheet.h
    @@ -272,8 +272,12 @@ static inline css_error css_stylesheet_style_unset(css_style *style,
     static inline css_error css_stylesheet_style_flag_value(css_style *style,
     		enum flag_value flag_value, opcode_t opcode)
     {
    +	enum flag flag = flag_value << 1;
    +	if (flag == FLAG_REVERT) {
    +		style->sheet->uses_revert = true;
    +	}
     	return css__stylesheet_style_append(style,
    -			buildOPV(opcode, flag_value << 1, 0));
    +			buildOPV(opcode, flag, 0));
     }
     
     css_error css__stylesheet_selector_create(css_stylesheet *sheet,
    -- 
    2.41.0
    
    

-Relationships
+Relationships

-Notes
phoebos

~0002412

phoebos (reporter)

The null dereference in src/select/select.c:1168 causes this segfault, and has been detected by your static analysis CI system for at least 4 months:

https://ci.netsurf-browser.org/jenkins/job/scan-build-libcss/361/clangScanBuildBugs/
phoebos

~0002413

phoebos (reporter)

ASAN output:

AddressSanitizer:DEADLYSIGNAL
=================================================================
==179658==ERROR: AddressSanitizer: SEGV on unknown address 0x0000000026e8 (pc 0x55f51d0c51f3 bp 0x000000000000 sp 0x7ffe57f77c60 T0)
==179658==The signal is caused by a READ memory access.
    #0 0x55f51d0c51f3 in css__select_revert_property_to_origin /tmp/21803/build/libcss/src/select/select.c:1168:40
    #1 0x55f51cbe66a2 in __sanitizer::BufferedStackTrace::UnwindImpl(unsigned long, unsigned long, void*, bool, unsigned int) Scrt1.c
    0000002 0x55f51cc12e5b in __sanitizer::ReportDeadlySignal(__sanitizer::SignalContext const&, unsigned int, void (*)(__sanitizer::SignalContext const&, void const*, __sanitizer::BufferedStackTrace*), void const*) Scrt1.c
    #3 0x55f51cbe0d53 in __asan::ScopedInErrorReport::~ScopedInErrorReport() Scrt1.c
    #4 0x55f51cbe109d in __asan::ReportDeadlySignal(__sanitizer::SignalContext const&) Scrt1.c
    #5 0x55f51cbdf62d in __asan::AsanOnDeadlySignal(int, void*, void*) Scrt1.c
    #6 0x7f1aacb3e733 in _setjmp /tmp/852136/build/musl/src/signal/x86_64/restore.s:1

AddressSanitizer can not provide additional info.
SUMMARY: AddressSanitizer: SEGV /tmp/21803/build/libcss/src/select/select.c:1168:40 in css__select_revert_property_to_origin
==179658==ABORTING
Michael Orlitzky

~0002416

Michael Orlitzky (reporter)

The "uses_revert" flag is not being set to true on stylesheets that obviously do contain a revert. That leads to uses_revert being false in the context, which leads to the "revert" pointer not being initialized. Then when we do finally encounter the revert, we try to dereference that (still NULL) pointer.

Here's a much simpler test case:

<html>
  <head>
    <title>hello</title>
    <style>
      body {
        outline: revert;
      }
    </style>
  </head>
  <body>
    


      hi
    


  </body>
</html>
Michael Orlitzky

~0002417

Michael Orlitzky (reporter)

^ There's a missing paragraph tag that got absorbed by mantis, but you get the idea.
Michael Orlitzky

~0002418

Michael Orlitzky (reporter)

Here's a patch to fix the issue. It was a problem with most shorthand properties (like "outline").
phoebos

~0002419

phoebos (reporter)

Thanks for your good work, the patch works for me too.
phoebos

~0002420

phoebos (reporter)

(In fact I now have a new segfault accessing the original page; it seems to be in libnsbmp, so I'll open a new issue).
Michael Drake

~0002426

Michael Drake (administrator)

Thanks both, for the report and the fix! Applied.
+Notes

-Issue History
Date Modified Username Field Change
2023-03-31 00:55 phoebos New Issue
2023-03-31 00:55 phoebos File Added: log
2023-03-31 09:57 phoebos Note Added: 0002412
2023-03-31 16:30 phoebos Note Added: 0002413
2023-08-12 19:09 Michael Orlitzky Note Added: 0002416
2023-08-12 19:10 Michael Orlitzky Note Added: 0002417
2023-08-13 00:27 Michael Orlitzky File Added: 0001-src-stylesheet.h-set-uses_revert-flag-for-shorthand-.patch
2023-08-13 00:27 Michael Orlitzky Note Added: 0002418
2023-08-13 01:47 phoebos Note Added: 0002419
2023-08-13 01:54 phoebos Note Added: 0002420
2023-09-17 18:53 Michael Drake Assigned To => Michael Drake
2023-09-17 18:53 Michael Drake Status new => resolved
2023-09-17 18:53 Michael Drake Resolution open => fixed
2023-09-17 18:53 Michael Drake Description Updated View Revisions
2023-09-17 18:53 Michael Drake Additional Information Updated View Revisions
2023-09-17 18:53 Michael Drake Note Added: 0002426
+Issue History